/*Distance Measurement with Ultrasonic sensor and leds*/
#include<Servo.h>

Servo myservo;
int servo_open = 180;
int servo_closed = 0;
int valve_state = 0; // variable to store the valve state .  0 when the valve is closed and 1 when it is opened
// this is to help to stop the servo motor continuous opening when the valve is already opened
// and also to stop the servo from continuous closing when the valve is already closed 
int trigPin = 9;
int echoPin = 10;
long duration;
int distance;
int min_distance = 20;
void setup(){
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
 // myservo.attach(3);
  Serial.begin(9600);
}
void loop() {
            digitalWrite(trigPin, LOW);
            delayMicroseconds(2);
            digitalWrite(trigPin,HIGH);
            delayMicroseconds(10);
            digitalWrite(trigPin,LOW);
            duration = pulseIn(echoPin,HIGH);
            distance = duration*0.0343/2;// to get the distance we multiply speed by duration(time) . speed of sound is 0.0343cm/second
            Serial.print("distance");
            Serial.println(distance);
            delay(1000);
            if(distance < min_distance && valve_state == 0){ // if hand is close to the device from 15cm below and valve is in closed state =0 
                   myservo.attach(3);
                   myservo.write(servo_open); // opens the servo motor
                   delay(800);
                   myservo.detach();
                  valve_state = 1; // put the state at 1== open so the motor wont keep opening 
            } 
            else if(distance > min_distance && valve_state == 1){  //if hand is further than 15cm and valve is open
                   myservo.attach(3);
                   myservo.write(servo_closed); // opens the servo motor
                   delay(800);
                   myservo.detach();
                  valve_state = 0; // change valve state to closed; 
                  }
         
}
